/* A Bison parser, made by GNU Bison 1.875a.  */

/* Skeleton parser for Yacc-like parsing with Bison,
   Copyright (C) 1984, 1989, 1990, 2000, 2001, 2002, 2003 Free Software Foundation, Inc.

   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.  */

/* As a special exception, when this file is copied by Bison into a
   Bison output file, you may use that output file without restriction.
   This special exception was added by the Free Software Foundation
   in version 1.24 of Bison.  */

/* Written by Richard Stallman by simplifying the original so called
   ``semantic'' parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     EQV = 258,
     IMP = 259,
     OR = 260,
     XOR = 261,
     AND = 262,
     NOT = 263,
     NOTEQUAL = 264,
     GREATEROREQUAL = 265,
     LESSOREQUAL = 266,
     MOD = 267,
     NEGATIONPRIORITY = 268,
     CRLF = 269,
     COLONCHAR = 270,
     IF = 271,
     THEN = 272,
     ELSE = 273,
     ELSEIF = 274,
     ENDIF = 275,
     SELECT = 276,
     CASE = 277,
     ENDSELECT = 278,
     IS = 279,
     WEND = 280,
     DO = 281,
     LOOP = 282,
     WHILE = 283,
     EXITDO = 284,
     DOWHILE = 285,
     DOUNTIL = 286,
     LOOPWHILE = 287,
     LOOPUNTIL = 288,
     SUB = 289,
     ENDSUB = 290,
     EXITSUB = 291,
     DECLARESUB = 292,
     FUNCTION = 293,
     ENDFUNCTION = 294,
     EXITFUNCTION = 295,
     DECLAREFUNCTION = 296,
     CALL = 297,
     FOR = 298,
     TO = 299,
     STEP = 300,
     NEXT = 301,
     EXITFOR = 302,
     GOTO = 303,
     GOSUB = 304,
     RETURN = 305,
     RESTORE = 306,
     END = 307,
     LET = 308,
     NUMBER = 309,
     STRING = 310,
     IDENTIFIER = 311,
     FUNCTIONNAME = 312,
     SUBNAME = 313,
     CONSTNAME = 314,
     PRINT = 315,
     USING = 316,
     FILENUM = 317,
     LPRINT = 318,
     OPEN = 319,
     OUTPUT = 320,
     INPUT = 321,
     APPEND = 322,
     RANDOM = 323,
     BINARY = 324,
     WRITE = 325,
     ACCESS = 326,
     LOCK = 327,
     CLOSE = 328,
     ON = 329,
     PLAY = 330,
     STOP = 331,
     OFF = 332,
     POKE = 333,
     SYSTEM = 334,
     LOCATE = 335,
     ERROR = 336,
     RESUME = 337,
     INKEY_S = 338,
     CSRLIN = 339,
     SPACE_S = 340,
     POS = 341,
     LEN = 342,
     FREEFILE = 343,
     DEFINT = 344,
     DEFSNG = 345,
     DEFDBL = 346,
     DEFSTR = 347,
     DEFLNG = 348,
     ONECHAR = 349,
     DATA = 350,
     READ = 351,
     INTEGER = 352,
     SINGLE = 353,
     DOUBLE = 354,
     LONG = 355,
     AS = 356,
     TYPE = 357,
     ENDTYPE = 358,
     DIM = 359,
     REDIM = 360,
     SHARED = 361,
     CONST = 362
   };
#endif
#define EQV 258
#define IMP 259
#define OR 260
#define XOR 261
#define AND 262
#define NOT 263
#define NOTEQUAL 264
#define GREATEROREQUAL 265
#define LESSOREQUAL 266
#define MOD 267
#define NEGATIONPRIORITY 268
#define CRLF 269
#define COLONCHAR 270
#define IF 271
#define THEN 272
#define ELSE 273
#define ELSEIF 274
#define ENDIF 275
#define SELECT 276
#define CASE 277
#define ENDSELECT 278
#define IS 279
#define WEND 280
#define DO 281
#define LOOP 282
#define WHILE 283
#define EXITDO 284
#define DOWHILE 285
#define DOUNTIL 286
#define LOOPWHILE 287
#define LOOPUNTIL 288
#define SUB 289
#define ENDSUB 290
#define EXITSUB 291
#define DECLARESUB 292
#define FUNCTION 293
#define ENDFUNCTION 294
#define EXITFUNCTION 295
#define DECLAREFUNCTION 296
#define CALL 297
#define FOR 298
#define TO 299
#define STEP 300
#define NEXT 301
#define EXITFOR 302
#define GOTO 303
#define GOSUB 304
#define RETURN 305
#define RESTORE 306
#define END 307
#define LET 308
#define NUMBER 309
#define STRING 310
#define IDENTIFIER 311
#define FUNCTIONNAME 312
#define SUBNAME 313
#define CONSTNAME 314
#define PRINT 315
#define USING 316
#define FILENUM 317
#define LPRINT 318
#define OPEN 319
#define OUTPUT 320
#define INPUT 321
#define APPEND 322
#define RANDOM 323
#define BINARY 324
#define WRITE 325
#define ACCESS 326
#define LOCK 327
#define CLOSE 328
#define ON 329
#define PLAY 330
#define STOP 331
#define OFF 332
#define POKE 333
#define SYSTEM 334
#define LOCATE 335
#define ERROR 336
#define RESUME 337
#define INKEY_S 338
#define CSRLIN 339
#define SPACE_S 340
#define POS 341
#define LEN 342
#define FREEFILE 343
#define DEFINT 344
#define DEFSNG 345
#define DEFDBL 346
#define DEFSTR 347
#define DEFLNG 348
#define ONECHAR 349
#define DATA 350
#define READ 351
#define INTEGER 352
#define SINGLE 353
#define DOUBLE 354
#define LONG 355
#define AS 356
#define TYPE 357
#define ENDTYPE 358
#define DIM 359
#define REDIM 360
#define SHARED 361
#define CONST 362




/* Copy the first part of user declarations.  */
#line 1 "qb.y"

/* C declarations */

#define YYDEBUG 1
#define YYERROR_VERBOSE 1



/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

#if ! defined (YYSTYPE) && ! defined (YYSTYPE_IS_DECLARED)
typedef int YYSTYPE;
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
# define YYSTYPE_IS_TRIVIAL 1
#endif



/* Copy the second part of user declarations.  */


/* Line 214 of yacc.c.  */
#line 309 "qb.tab.c"

#if ! defined (yyoverflow) || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# if YYSTACK_USE_ALLOCA
#  define YYSTACK_ALLOC alloca
# else
#  ifndef YYSTACK_USE_ALLOCA
#   if defined (alloca) || defined (_ALLOCA_H)
#    define YYSTACK_ALLOC alloca
#   else
#    ifdef __GNUC__
#     define YYSTACK_ALLOC __builtin_alloca
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning. */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (0)
# else
#  if defined (__STDC__) || defined (__cplusplus)
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   define YYSIZE_T size_t
#  endif
#  define YYSTACK_ALLOC malloc
#  define YYSTACK_FREE free
# endif
#endif /* ! defined (yyoverflow) || YYERROR_VERBOSE */


#if (! defined (yyoverflow) \
     && (! defined (__cplusplus) \
	 || (YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  short yyss;
  YYSTYPE yyvs;
  };

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (short) + sizeof (YYSTYPE))				\
      + YYSTACK_GAP_MAXIMUM)

/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  register YYSIZE_T yyi;		\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (0)
#  endif
# endif

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack)					\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack, Stack, yysize);				\
	Stack = &yyptr->Stack;						\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (0)

#endif

#if defined (__STDC__) || defined (__cplusplus)
   typedef signed char yysigned_char;
#else
   typedef short yysigned_char;
#endif

/* YYFINAL -- State number of the termination state. */
#define YYFINAL  3
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   2030

/* YYNTOKENS -- Number of terminals. */
#define YYNTOKENS  122
/* YYNNTS -- Number of nonterminals. */
#define YYNNTS  93
/* YYNRULES -- Number of rules. */
#define YYNRULES  309
/* YYNRULES -- Number of states. */
#define YYNSTATES  574

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   362

#define YYTRANSLATE(YYX) 						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const unsigned char yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     117,   118,    19,    15,   119,    16,   121,    20,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,   120,
       9,    11,    10,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,    18,     2,    22,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,    12,    13,    14,    17,    21,    23,
      24,    25,    26,    27,    28,    29,    30,    31,    32,    33,
      34,    35,    36,    37,    38,    39,    40,    41,    42,    43,
      44,    45,    46,    47,    48,    49,    50,    51,    52,    53,
      54,    55,    56,    57,    58,    59,    60,    61,    62,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,    75,    76,    77,    78,    79,    80,    81,    82,    83,
      84,    85,    86,    87,    88,    89,    90,    91,    92,    93,
      94,    95,    96,    97,    98,    99,   100,   101,   102,   103,
     104,   105,   106,   107,   108,   109,   110,   111,   112,   113,
     114,   115,   116
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const unsigned short yyprhs[] =
{
       0,     0,     3,     5,     8,     9,    11,    13,    15,    17,
      19,    21,    23,    26,    28,    30,    34,    37,    38,    46,
      54,    59,    64,    68,    70,    74,    76,    83,    86,    88,
      91,    93,    99,   103,   107,   111,   115,   119,   123,   127,
     129,   133,   135,   141,   143,   145,   147,   149,   151,   153,
     156,   157,   161,   163,   170,   176,   182,   187,   192,   194,
     196,   201,   207,   213,   219,   225,   231,   242,   249,   255,
     256,   258,   260,   262,   266,   269,   272,   273,   275,   277,
     279,   281,   283,   291,   297,   300,   301,   306,   312,   318,
     324,   330,   336,   347,   354,   360,   361,   364,   365,   367,
     371,   375,   379,   383,   387,   391,   395,   397,   401,   403,
     405,   407,   410,   412,   414,   417,   419,   421,   425,   427,
     430,   432,   435,   437,   439,   441,   443,   445,   447,   449,
     452,   455,   458,   460,   468,   473,   478,   481,   484,   486,
     491,   494,   497,   500,   503,   506,   509,   514,   517,   520,
     523,   525,   527,   529,   531,   534,   538,   541,   543,   544,
     548,   550,   554,   556,   557,   568,   575,   580,   583,   592,
     600,   603,   606,   609,   612,   615,   616,   620,   623,   626,
     627,   629,   633,   636,   639,   640,   644,   645,   648,   649,
     653,   656,   662,   665,   668,   670,   672,   674,   676,   678,
     680,   682,   684,   686,   688,   690,   694,   696,   697,   701,
     703,   708,   710,   714,   717,   721,   724,   726,   727,   731,
     734,   737,   741,   743,   750,   755,   759,   761,   765,   767,
     771,   773,   777,   779,   786,   791,   795,   799,   803,   807,
     811,   814,   818,   822,   826,   830,   834,   838,   842,   846,
     850,   854,   858,   862,   866,   869,   873,   875,   879,   883,
     887,   891,   895,   898,   902,   906,   910,   914,   918,   922,
     926,   930,   934,   938,   942,   946,   950,   953,   955,   957,
     959,   961,   963,   965,   967,   969,   971,   973,   975,   976,
     981,   983,   987,   989,   994,   996,  1000,  1002,  1004,  1006,
    1008,  1010,  1012,  1014,  1016,  1018,  1020,  1022,  1027,  1032
};

/* YYRHS -- A `-1'-separated list of the rules' RHS. */
static const short yyrhs[] =
{
     123,     0,    -1,   124,    -1,   124,   125,    -1,    -1,   127,
      -1,   128,    -1,   129,    -1,   130,    -1,   133,    -1,   137,
      -1,   140,    -1,   151,   164,    -1,   166,    -1,   164,    -1,
     117,   132,   118,    -1,   117,   118,    -1,    -1,    43,   182,
     126,    23,   152,    44,    23,    -1,    47,   183,   126,    23,
     152,    48,    23,    -1,    46,   182,   126,    23,    -1,    50,
     183,   126,    23,    -1,   186,   110,   213,    -1,   186,    -1,
     132,   119,   131,    -1,   131,    -1,   111,   185,    23,   134,
     112,    23,    -1,   134,   135,    -1,   135,    -1,   136,    23,
      -1,    23,    -1,   136,   119,   186,   110,   213,    -1,   186,
     110,   213,    -1,    98,   138,    23,    -1,    99,   138,    23,
      -1,   100,   138,    23,    -1,   101,   138,    23,    -1,   102,
     138,    23,    -1,   138,   119,   139,    -1,   139,    -1,   103,
      16,   103,    -1,   103,    -1,   116,   187,    11,   201,    23,
      -1,   169,    -1,   144,    -1,   147,    -1,   146,    -1,   148,
      -1,   149,    -1,   143,    24,    -1,    -1,   143,    24,   141,
      -1,   141,    -1,    25,   204,    26,   145,    27,   145,    -1,
      25,   204,    26,    27,   145,    -1,    25,   204,    26,   145,
      27,    -1,    25,   204,    26,    27,    -1,    25,   204,    26,
     145,    -1,    63,    -1,   143,    -1,    35,    24,   142,    36,
      -1,    39,   204,    24,   142,    36,    -1,    40,   204,    24,
     142,    36,    -1,    35,    24,   142,    41,   204,    -1,    35,
      24,   142,    42,   204,    -1,    37,   204,    24,   142,    34,
      -1,    52,   212,    11,   203,    53,   203,   161,    24,   142,
      55,    -1,    30,    31,   201,    24,   150,    32,    -1,   150,
      31,   163,    24,   142,    -1,    -1,   153,    -1,   169,    -1,
     144,    -1,   152,   151,   164,    -1,   152,   166,    -1,   152,
     164,    -1,    -1,   154,    -1,   157,    -1,   156,    -1,   158,
      -1,   159,    -1,    25,   204,    26,    23,   152,   155,    29,
      -1,    28,   204,    26,   152,   155,    -1,    27,   152,    -1,
      -1,    35,   164,   152,    36,    -1,    39,   204,   164,   152,
      36,    -1,    40,   204,   164,   152,    36,    -1,    35,   164,
     152,    41,   204,    -1,    35,   164,   152,    42,   204,    -1,
      37,   204,   164,   152,    34,    -1,    52,   212,    11,   203,
      53,   203,   161,   164,   152,    55,    -1,    30,    31,   201,
     165,   160,    32,    -1,   160,    31,   163,   164,   152,    -1,
      -1,    54,   203,    -1,    -1,    27,    -1,    33,    10,   201,
      -1,    33,     9,   201,    -1,    33,    11,   201,    -1,    33,
      14,   201,    -1,    33,    13,   201,    -1,    33,    12,   201,
      -1,   201,    53,   201,    -1,   201,    -1,   163,   119,   162,
      -1,   162,    -1,    24,    -1,    23,    -1,   165,   164,    -1,
     164,    -1,    63,    -1,   184,    24,    -1,   184,    -1,    63,
      -1,   168,   119,   167,    -1,   167,    -1,    62,   180,    -1,
     180,    -1,    59,   167,    -1,    59,    -1,    38,    -1,    56,
      -1,    45,    -1,    49,    -1,   181,    -1,   194,    -1,    57,
     167,    -1,    58,   167,    -1,    60,   167,    -1,    60,    -1,
      83,    84,   117,   201,   118,    58,   167,    -1,    83,   203,
      58,   168,    -1,    83,    90,    57,   167,    -1,    91,   167,
      -1,    91,    55,    -1,    91,    -1,    69,    71,   119,   192,
      -1,    69,   192,    -1,    72,   192,    -1,    84,    85,    -1,
      84,    86,    -1,    84,    83,    -1,    84,   205,    -1,    87,
     203,   119,   203,    -1,   104,   170,    -1,    88,   205,    -1,
     105,   171,    -1,    88,    -1,    61,    -1,   173,    -1,   174,
      -1,    82,   172,    -1,   170,   119,    64,    -1,   170,   119,
      -1,    64,    -1,    -1,   171,   119,   212,    -1,   212,    -1,
     172,   119,   188,    -1,   188,    -1,    -1,    89,   207,   119,
     207,   119,   207,   119,   203,   119,   203,    -1,    89,   207,
     119,   207,   119,   207,    -1,    89,   207,   119,   207,    -1,
      89,   207,    -1,    73,   205,   175,   176,   177,   110,   188,
     178,    -1,    73,   205,   119,   188,   119,   205,   179,    -1,
      52,    74,    -1,    52,    75,    -1,    52,    76,    -1,    52,
      77,    -1,    52,    78,    -1,    -1,    80,   105,    79,    -1,
      80,   105,    -1,    80,    79,    -1,    -1,   115,    -1,    81,
     105,    79,    -1,    81,   105,    -1,    81,    79,    -1,    -1,
      96,    11,   203,    -1,    -1,   119,   203,    -1,    -1,   212,
      11,   201,    -1,    67,   190,    -1,    51,   182,   117,   190,
     118,    -1,    51,   182,    -1,    65,   189,    -1,    67,    -1,
      65,    -1,    66,    -1,    65,    -1,    65,    -1,    65,    -1,
      65,    -1,    65,    -1,    71,    -1,   203,    -1,   202,    -1,
     202,   119,   191,    -1,   191,    -1,    -1,   191,   119,   201,
      -1,   201,    -1,    70,   205,   120,   193,    -1,   193,    -1,
     193,   120,   201,    -1,   193,   120,    -1,   193,   119,   201,
      -1,   193,   119,    -1,   201,    -1,    -1,   113,   115,   195,
      -1,   113,   195,    -1,   114,   199,    -1,   195,   119,   196,
      -1,   196,    -1,   186,   117,   197,   118,   110,   213,    -1,
     186,   117,   197,   118,    -1,   186,   110,   213,    -1,   186,
      -1,   197,   119,   198,    -1,   198,    -1,   203,    53,   203,
      -1,   203,    -1,   199,   119,   200,    -1,   200,    -1,   186,
     117,   197,   118,   110,   213,    -1,   186,   117,   197,   118,
      -1,   201,     4,   201,    -1,   201,     3,   201,    -1,   201,
       6,   201,    -1,   201,     5,   201,    -1,   201,     7,   201,
      -1,     8,   201,    -1,   201,    10,   201,    -1,   201,     9,
     201,    -1,   201,    11,   201,    -1,   201,    14,   201,    -1,
     201,    13,   201,    -1,   201,    12,   201,    -1,   201,    15,
     201,    -1,   201,    16,   201,    -1,   201,    17,   201,    -1,
     201,    18,   201,    -1,   201,    20,   201,    -1,   201,    19,
     201,    -1,   201,    22,   201,    -1,    16,   201,    -1,   117,
     201,   118,    -1,   206,    -1,   202,     4,   201,    -1,   202,
       3,   201,    -1,   202,     6,   201,    -1,   202,     5,   201,
      -1,   202,     7,   201,    -1,     8,   201,    -1,   202,    10,
     201,    -1,   202,     9,   201,    -1,   202,    11,   201,    -1,
     202,    14,   201,    -1,   202,    13,   201,    -1,   202,    12,
     201,    -1,   202,    15,   201,    -1,   202,    16,   201,    -1,
     202,    17,   201,    -1,   202,    18,   201,    -1,   202,    20,
     201,    -1,   202,    19,   201,    -1,   202,    22,   201,    -1,
      16,   201,    -1,   206,    -1,   201,    -1,   201,    -1,   201,
      -1,   211,    -1,   208,    -1,   214,    -1,    63,    -1,    64,
      -1,    68,    -1,   203,    -1,    -1,    66,   117,   191,   118,
      -1,    66,    -1,   209,   119,   203,    -1,   203,    -1,   186,
     117,   209,   118,    -1,   186,    -1,   211,   121,   210,    -1,
     210,    -1,   211,    -1,   106,    -1,   107,    -1,   108,    -1,
      64,    -1,   109,    -1,   185,    -1,    92,    -1,    93,    -1,
      97,    -1,    94,   117,   203,   118,    -1,    95,   117,   203,
     118,    -1,    96,   117,   205,   118,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const unsigned short yyrline[] =
{
       0,    84,    84,    88,    89,    93,    94,    95,    96,    97,
      98,    99,   100,   101,   102,   106,   107,   108,   111,   114,
     117,   120,   123,   124,   127,   128,   133,   136,   137,   140,
     141,   144,   145,   149,   150,   151,   152,   153,   156,   157,
     160,   161,   165,   170,   171,   172,   173,   174,   175,   178,
     179,   182,   183,   188,   189,   190,   191,   192,   195,   196,
     200,   201,   202,   203,   204,   207,   210,   213,   216,   217,
     221,   222,   223,   226,   227,   228,   229,   233,   234,   235,
     236,   237,   240,   243,   244,   245,   248,   249,   250,   251,
     252,   255,   258,   261,   264,   265,   270,   271,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   285,   286,   290,
     291,   300,   301,   305,   306,   309,   310,   313,   314,   321,
     322,   323,   324,   325,   326,   327,   328,   329,   330,   331,
     332,   333,   334,   335,   336,   337,   338,   339,   340,   341,
     342,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   360,   361,   362,   363,   366,
     367,   371,   372,   373,   377,   379,   381,   383,   387,   391,
     398,   399,   400,   401,   402,   403,   406,   407,   408,   409,
     412,   413,   414,   415,   416,   419,   420,   423,   424,   428,
     432,   433,   434,   435,   444,   445,   448,   449,   452,   455,
     458,   461,   464,   465,   469,   470,   474,   475,   478,   479,
     483,   484,   487,   488,   489,   490,   491,   492,   496,   497,
     498,   501,   502,   505,   506,   507,   508,   511,   512,   515,
     516,   519,   520,   523,   524,   528,   529,   530,   531,   532,
     533,   535,   536,   537,   538,   539,   540,   542,   543,   544,
     545,   546,   547,   548,   550,   552,   554,   558,   559,   560,
     561,   562,   563,   565,   566,   567,   568,   569,   570,   572,
     573,   574,   575,   576,   577,   578,   580,   582,   586,   589,
     592,   596,   597,   598,   599,   600,   601,   605,   606,   610,
     612,   616,   617,   621,   622,   625,   626,   630,   634,   635,
     636,   637,   638,   639,   643,   644,   645,   646,   647,   648
};
#endif

#if YYDEBUG || YYERROR_VERBOSE
/* YYTNME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals. */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "EQV", "IMP", "OR", "XOR", "AND", "NOT", 
  "'<'", "'>'", "'='", "NOTEQUAL", "GREATEROREQUAL", "LESSOREQUAL", "'+'", 
  "'-'", "MOD", "'\\\\'", "'*'", "'/'", "NEGATIONPRIORITY", "'^'", "CRLF", 
  "COLONCHAR", "IF", "THEN", "ELSE", "ELSEIF", "ENDIF", "SELECT", "CASE", 
  "ENDSELECT", "IS", "WEND", "DO", "LOOP", "WHILE", "EXITDO", "DOWHILE", 
  "DOUNTIL", "LOOPWHILE", "LOOPUNTIL", "SUB", "ENDSUB", "EXITSUB", 
  "DECLARESUB", "FUNCTION", "ENDFUNCTION", "EXITFUNCTION", 
  "DECLAREFUNCTION", "CALL", "FOR", "TO", "STEP", "NEXT", "EXITFOR", 
  "GOTO", "GOSUB", "RETURN", "RESTORE", "END", "LET", "NUMBER", "STRING", 
  "IDENTIFIER", "FUNCTIONNAME", "SUBNAME", "CONSTNAME", "PRINT", "USING", 
  "FILENUM", "LPRINT", "OPEN", "OUTPUT", "INPUT", "APPEND", "RANDOM", 
  "BINARY", "WRITE", "ACCESS", "LOCK", "CLOSE", "ON", "PLAY", "STOP", 
  "OFF", "POKE", "SYSTEM", "LOCATE", "ERROR", "RESUME", "INKEY_S", 
  "CSRLIN", "SPACE_S", "POS", "LEN", "FREEFILE", "DEFINT", "DEFSNG", 
  "DEFDBL", "DEFSTR", "DEFLNG", "ONECHAR", "DATA", "READ", "INTEGER", 
  "SINGLE", "DOUBLE", "LONG", "AS", "TYPE", "ENDTYPE", "DIM", "REDIM", 
  "SHARED", "CONST", "'('", "')'", "','", "';'", "'.'", "$accept", 
  "program", "definitions0", "definition1", "sub_params_decl", "sub", 
  "function", "declaresub", "declarefunction", "paramdeclaration1", 
  "paramdeclarations2", "typedef", "typeelements2", "typeelement1", 
  "typeelementdef", "deftypedef", "characterranges2", "characterrange1", 
  "constdef", "shortstatement1", "shortstatements0", "shortstatements2", 
  "shortif", "shortifblock2", "shortdoloop", "shortwhile", "shortfornext", 
  "shortselect", "shortcaselist", "longstatement1", "longstatements0", 
  "longstructure", "longif", "longelselist", "longdoloop", "longwhile", 
  "longfornext", "longselect", "longcaselist", "forstep", "casevalue1", 
  "casevalues2", "separator1", "separators2", "anylabeldef", "anylabel1", 
  "anylabel2", "simplestatement", "dataparams0", "readparams2", 
  "closeparams0", "locate", "open", "open_formode", "open_accessmode", 
  "open_lockmode", "open_lenmode", "open_reclenmode", "assignment", 
  "subcall", "autosubname", "autofunctionname", "autolabelname", 
  "autousertype", "autovarname", "autoconstname", "autofilenum", 
  "subcallparamlist_no_parenthesis", "subcallparams0", "subcallparams2", 
  "printspec", "printparams0", "dim", "dimdefs2", "dimdef1", 
  "dimindexdefs2", "dimindexdef1", "redimdefs2", "redimdef1", "expr", 
  "expr_no_parenthesis", "numexpr", "boolexpr", "stringexpr", 
  "simple_expr", "optional_numexpr", "functioncall", "indexlist", 
  "varname", "var", "target", "type", "builtinfunc", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const unsigned short yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,    60,
      62,    61,   264,   265,   266,    43,    45,   267,    92,    42,
      47,   268,    94,   269,   270,   271,   272,   273,   274,   275,
     276,   277,   278,   279,   280,   281,   282,   283,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   302,   303,   304,   305,
     306,   307,   308,   309,   310,   311,   312,   313,   314,   315,
     316,   317,   318,   319,   320,   321,   322,   323,   324,   325,
     326,   327,   328,   329,   330,   331,   332,   333,   334,   335,
     336,   337,   338,   339,   340,   341,   342,   343,   344,   345,
     346,   347,   348,   349,   350,   351,   352,   353,   354,   355,
     356,   357,   358,   359,   360,   361,   362,    40,    41,    44,
      59,    46
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const unsigned char yyr1[] =
{
       0,   122,   123,   124,   124,   125,   125,   125,   125,   125,
     125,   125,   125,   125,   125,   126,   126,   126,   127,   128,
     129,   130,   131,   131,   132,   132,   133,   134,   134,   135,
     135,   136,   136,   137,   137,   137,   137,   137,   138,   138,
     139,   139,   140,   141,   141,   141,   141,   141,   141,   142,
     142,   143,   143,   144,   144,   144,   144,   144,   145,   145,
     146,   146,   146,   146,   146,   147,   148,   149,   150,   150,
     151,   151,   151,   152,   152,   152,   152,   153,   153,   153,
     153,   153,   154,   155,   155,   155,   156,   156,   156,   156,
     156,   157,   158,   159,   160,   160,   161,   161,   162,   162,
     162,   162,   162,   162,   162,   162,   162,   163,   163,   164,
     164,   165,   165,   166,   166,   167,   167,   168,   168,   169,
     169,   169,   169,   169,   169,   169,   169,   169,   169,   169,
     169,   169,   169,   169,   169,   169,   169,   169,   169,   169,
     169,   169,   169,   169,   169,   169,   169,   169,   169,   169,
     169,   169,   169,   169,   169,   170,   170,   170,   170,   171,
     171,   172,   172,   172,   173,   173,   173,   173,   174,   174,
     175,   175,   175,   175,   175,   175,   176,   176,   176,   176,
     177,   177,   177,   177,   177,   178,   178,   179,   179,   180,
     181,   181,   181,   181,   182,   182,   183,   183,   184,   185,
     186,   187,   188,   188,   189,   189,   190,   190,   191,   191,
     192,   192,   193,   193,   193,   193,   193,   193,   194,   194,
     194,   195,   195,   196,   196,   196,   196,   197,   197,   198,
     198,   199,   199,   200,   200,   201,   201,   201,   201,   201,
     201,   201,   201,   201,   201,   201,   201,   201,   201,   201,
     201,   201,   201,   201,   201,   201,   201,   202,   202,   202,
     202,   202,   202,   202,   202,   202,   202,   202,   202,   202,
     202,   202,   202,   202,   202,   202,   202,   202,   203,   204,
     205,   206,   206,   206,   206,   206,   206,   207,   207,   208,
     208,   209,   209,   210,   210,   211,   211,   212,   213,   213,
     213,   213,   213,   213,   214,   214,   214,   214,   214,   214
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const unsigned char yyr2[] =
{
       0,     2,     1,     2,     0,     1,     1,     1,     1,     1,
       1,     1,     2,     1,     1,     3,     2,     0,     7,     7,
       4,     4,     3,     1,     3,     1,     6,     2,     1,     2,
       1,     5,     3,     3,     3,     3,     3,     3,     3,     1,
       3,     1,     5,     1,     1,     1,     1,     1,     1,     2,
       0,     3,     1,     6,     5,     5,     4,     4,     1,     1,
       4,     5,     5,     5,     5,     5,    10,     6,     5,     0,
       1,     1,     1,     3,     2,     2,     0,     1,     1,     1,
       1,     1,     7,     5,     2,     0,     4,     5,     5,     5,
       5,     5,    10,     6,     5,     0,     2,     0,     1,     3,
       3,     3,     3,     3,     3,     3,     1,     3,     1,     1,
       1,     2,     1,     1,     2,     1,     1,     3,     1,     2,
       1,     2,     1,     1,     1,     1,     1,     1,     1,     2,
       2,     2,     1,     7,     4,     4,     2,     2,     1,     4,
       2,     2,     2,     2,     2,     2,     4,     2,     2,     2,
       1,     1,     1,     1,     2,     3,     2,     1,     0,     3,
       1,     3,     1,     0,    10,     6,     4,     2,     8,     7,
       2,     2,     2,     2,     2,     0,     3,     2,     2,     0,
       1,     3,     2,     2,     0,     3,     0,     2,     0,     3,
       2,     5,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     1,     0,     3,     1,
       4,     1,     3,     2,     3,     2,     1,     0,     3,     2,
       2,     3,     1,     6,     4,     3,     1,     3,     1,     3,
       1,     3,     1,     6,     4,     3,     3,     3,     3,     3,
       2,     3,     3,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     2,     3,     1,     3,     3,     3,
       3,     3,     2,     3,     3,     3,     3,     3,     3,     3,
       3,     3,     3,     3,     3,     3,     2,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     0,     4,
       1,     3,     1,     4,     1,     3,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     4,     4,     4
};

/* YYDEFACT[STATE-NAME] -- Default rule to reduce with in state
   STATE-NUM when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const unsigned short yydefact[] =
{
       4,     0,     2,     1,   110,   109,     0,     0,     0,     0,
     123,     0,     0,     0,   125,     0,     0,   126,     0,     0,
       0,   124,     0,     0,   122,   132,   151,     0,   113,   200,
     207,   217,   217,     0,   163,     0,     0,     0,   150,   288,
     138,     0,     0,     0,     0,     0,   158,     0,     0,     0,
       0,     0,     3,     5,     6,     7,     8,     9,    10,    11,
      72,     0,    70,    77,    79,    78,    80,    81,    14,    13,
      71,   152,   153,   120,   127,     0,   294,   128,   296,   297,
       0,     0,     0,   284,   285,   200,   290,   286,   304,   305,
       0,     0,     0,   306,     0,   279,     0,   256,   282,   281,
     283,     0,    76,     0,     0,     0,   195,   194,    17,    17,
     197,   196,    17,    17,   192,     0,   116,   198,   129,   115,
     130,   121,   131,   119,     0,     0,   193,   204,   277,   190,
     206,   209,     0,     0,   140,   211,   216,   141,   280,   175,
     202,   154,   162,   278,   203,     0,     0,     0,   144,   142,
     143,   145,     0,   148,   287,   167,   137,   136,    41,     0,
      39,     0,     0,     0,     0,   157,   147,   149,   160,   199,
       0,     0,   226,   219,   222,     0,   220,   232,   201,     0,
      12,   114,     0,     0,     0,   240,   254,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,    76,    76,    76,     0,     0,     0,     0,
       0,   207,     0,   262,   276,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   217,   215,   213,     0,
       0,   179,     0,     0,     0,     0,     0,   288,     0,    33,
       0,    34,    35,    36,    37,   156,     0,     0,   218,     0,
       0,     0,     0,     0,     0,   292,     0,   295,   189,     0,
       0,     0,     0,   255,   236,   235,   238,   237,   239,   242,
     241,   243,   246,   245,   244,   247,   248,   249,   250,   252,
     251,   253,    76,     0,    56,     0,     0,     0,     0,     0,
       0,    58,   200,    52,    59,    44,    57,    46,    45,    47,
      48,    43,   112,    95,    86,     0,     0,     0,    75,    74,
       0,     0,     0,    16,    25,     0,    23,    76,    20,    76,
      21,     0,     0,   258,   257,   260,   259,   261,   264,   263,
     265,   268,   267,   266,   269,   270,   271,   272,   274,   273,
     275,   205,   208,   217,   139,   214,   212,   170,   171,   172,
     173,   174,     0,     0,   184,   161,     0,   135,   118,   134,
     146,   166,    40,    38,   155,   159,    30,     0,    28,     0,
       0,   301,   298,   299,   300,   302,   303,   225,     0,   228,
     230,   221,     0,   231,     0,   293,     0,   289,   307,   308,
     309,    85,     0,    54,     0,    50,     0,     0,     0,     0,
       0,    55,     0,   111,    89,    90,    73,    91,    87,    88,
      15,     0,     0,     0,     0,   191,     0,   210,     0,   178,
     177,     0,   180,     0,     0,     0,   288,     0,    27,    29,
       0,     0,   224,     0,     0,   234,    42,   291,    76,     0,
       0,     0,     0,     0,     0,    50,    50,    50,     0,    51,
      53,     0,    93,    24,    22,     0,     0,    97,   188,   176,
     183,   182,     0,     0,   117,   165,    26,     0,    32,     0,
     227,   229,     0,    84,     0,    82,    69,    60,     0,     0,
      49,     0,     0,     0,     0,    98,     0,   108,     0,   106,
      18,    19,     0,     0,     0,   169,   181,   186,   133,     0,
       0,   223,   233,    76,     0,    63,    64,    65,    61,    62,
       0,     0,     0,     0,     0,     0,     0,     0,    76,     0,
      96,    76,   187,     0,   168,     0,    31,    85,     0,    67,
      97,   100,    99,   101,   104,   103,   102,   107,    94,   105,
       0,     0,     0,    83,     0,     0,    92,   185,   164,    50,
      50,    68,     0,    66
};

/* YYDEFGOTO[NTERM-NUM]. */
static const short yydefgoto[] =
{
      -1,     1,     2,    52,   217,    53,    54,    55,    56,   334,
     335,    57,   387,   388,   389,    58,   159,   160,    59,   313,
     463,   464,    60,   316,   317,   318,   319,   320,   524,   327,
     212,    62,    63,   460,    64,    65,    66,    67,   422,   513,
     507,   508,   328,   323,   329,   118,   379,    70,   166,   167,
     141,    71,    72,   251,   374,   443,   544,   515,    73,    74,
     108,   112,    75,   396,    76,   179,   142,   126,   129,   130,
     134,   135,    77,   173,   174,   398,   399,   176,   177,   143,
     127,   144,    96,   139,    97,   155,    98,   276,    78,    99,
      80,   397,   100
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -405
static const short yypact[] =
{
    -405,    75,   816,  -405,  -405,  -405,   741,    -7,   113,   741,
    -405,   741,   741,    36,  -405,    36,    18,  -405,    18,    36,
      33,  -405,    52,    52,    52,    52,  -405,    33,  -405,  1809,
     741,    48,   682,   741,   698,   623,   564,   741,   741,   741,
      67,   -36,   -36,   -36,   -36,   -36,    25,    33,    99,     8,
      33,   106,  -405,  -405,  -405,  -405,  -405,  -405,  -405,  -405,
    -405,   113,  -405,  -405,  -405,  -405,  -405,  -405,  -405,  -405,
    -405,  -405,  -405,  -405,  -405,    68,    62,  -405,  -405,    56,
     196,   741,   741,  -405,  -405,  -405,    92,  -405,  -405,  -405,
      94,    97,   103,  -405,   741,  1976,   190,  -405,  -405,    56,
    -405,   741,  -405,   113,   113,   113,  -405,  -405,   124,   124,
    -405,  -405,   124,   124,   131,   246,  -405,  -405,  -405,  -405,
    -405,  -405,  -405,  -405,   741,   741,  -405,   584,  -405,  -405,
     140,  1976,   741,   155,  -405,    28,  1976,  -405,  1976,   -32,
    -405,   176,  -405,  1976,  -405,   192,   259,   262,  -405,  -405,
    -405,  -405,   204,  -405,  -405,   205,  -405,  -405,   309,    -9,
    -405,    20,    27,    31,    35,  -405,   207,   213,  -405,  -405,
     311,    33,   -29,   221,  -405,   224,   223,  -405,  -405,   332,
    -405,  -405,   741,    33,   741,  2008,   322,   741,   741,   741,
     741,   381,   741,   741,   741,   741,   741,   741,   741,   741,
     741,   741,   741,   741,   741,   741,   741,   741,   741,   741,
    1470,  1911,   901,  -405,  -405,  -405,    11,   338,   339,   340,
     341,   741,   741,  2008,   322,   741,   741,   741,   741,   741,
     741,   741,   741,   741,   741,   741,   741,   741,   741,   741,
     741,   741,   741,   741,   741,   238,   682,   741,   741,    83,
     698,   280,   698,   741,    52,    52,   741,   741,   263,  -405,
     -36,  -405,  -405,  -405,  -405,   301,    33,    39,   221,    60,
     741,    33,   741,    33,   741,  -405,   143,  -405,  1976,   164,
     249,   250,   251,  -405,  1994,  1994,  1876,  1876,  2008,   236,
     236,   236,   236,   236,   236,   335,   335,   133,   165,   322,
     322,   322,  -405,   741,  1683,   342,   346,   741,   741,   741,
      33,  -405,  1816,  -405,   351,  -405,   349,  -405,  -405,  -405,
    -405,  -405,  -405,   113,  -405,   741,   741,   113,  -405,  -405,
    1044,  1115,  1186,  -405,  -405,   167,   267,  -405,  -405,  -405,
    -405,   260,   326,  1994,  1994,  1876,  1876,  2008,   236,   236,
     236,   236,   236,   236,   335,   335,   133,   165,   322,   322,
     322,   140,  1976,   741,  -405,  1976,  1976,  -405,  -405,  -405,
    -405,  -405,   261,   -11,   -15,  -405,   604,  -405,  -405,   264,
    -405,   285,  -405,  -405,  -405,  -405,  -405,    26,  -405,    37,
     271,  -405,  -405,  -405,  -405,  -405,  -405,  -405,   170,  -405,
     329,  -405,   179,  -405,  1955,  -405,   741,  -405,  -405,  -405,
    -405,   972,   376,  -405,   741,  1754,   382,   383,   384,   394,
    1754,  1683,   269,  -405,  -405,  -405,  -405,  -405,  -405,  -405,
    -405,    33,    60,  1257,  1328,  -405,   741,    28,   741,  -405,
     333,   -10,  -405,   306,   359,    52,   741,   397,  -405,  -405,
      33,    60,   312,   741,   741,   313,  -405,  -405,  -405,   741,
     392,  1612,  1933,    44,   400,  1754,  1754,  1754,   741,  -405,
    -405,   636,  -405,  -405,  -405,   402,   403,   373,   310,  -405,
    -405,   356,   698,    52,  -405,   317,  -405,   318,  -405,    60,
    -405,  -405,    60,  1541,   411,  -405,  -405,  -405,   741,   741,
    1754,   404,   407,   408,   386,  -405,   337,  -405,   -20,   807,
    -405,  -405,   741,   113,   741,  -405,  -405,   344,  -405,   741,
      60,  -405,  -405,  -405,   283,  -405,  -405,  -405,  -405,  -405,
     741,   741,   741,   741,   741,   741,   741,   636,  -405,   741,
    -405,  -405,  -405,   434,  -405,   327,  -405,   972,   636,  -405,
     373,  1976,  1976,  1976,  1976,  1976,  1976,  -405,  1541,  1976,
    1399,   741,   741,  -405,     7,   423,  -405,  -405,  -405,  1754,
    1754,  -405,   393,  -405
};

/* YYPGOTO[NTERM-NUM].  */
static const short yypgoto[] =
{
    -405,  -405,  -405,  -405,    69,  -405,  -405,  -405,  -405,    19,
    -405,  -405,  -405,    64,  -405,  -405,   234,   189,  -405,  -404,
    -395,  -171,  -155,  -294,  -405,  -405,  -405,  -405,  -405,   451,
    -167,  -405,  -405,   -93,  -405,  -405,  -405,  -405,  -405,   -94,
     -80,   -87,     4,  -405,   464,    17,  -405,  -128,  -405,  -405,
    -405,  -405,  -405,  -405,  -405,  -405,  -405,  -405,   441,  -405,
      87,   453,    13,   424,     2,  -405,  -237,  -405,   252,  -164,
       1,   111,  -405,   304,   208,   209,    23,  -405,   210,    -4,
    -405,    24,    10,   -27,   -28,  -227,  -405,  -405,   297,    -2,
      -3,  -358,  -405
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If zero, do what YYDEFACT says.
   If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -199
static const short yytable[] =
{
      79,   128,    95,     4,     5,    95,    68,    95,    95,   151,
     413,   153,   102,   372,   259,   375,   469,   115,    79,   103,
     249,   104,   105,   279,   101,    79,   131,   136,   136,   138,
     381,   569,   138,   137,   138,   119,   119,   119,   119,   314,
     120,   121,   122,   261,   168,    79,   330,   331,   332,   386,
     262,   172,   175,   119,   263,   315,    81,   157,   264,   147,
     449,   152,   386,   154,    82,   180,   441,   158,   439,   480,
     501,   502,   503,    85,   474,     3,    85,   185,   186,   361,
     497,   269,   321,   110,   111,   498,   499,   250,   270,   165,
     191,    85,   181,   488,   440,   481,   469,   211,    85,   537,
     442,   106,   109,   107,    85,   245,   114,   213,   214,   215,
     260,    83,    84,    85,    86,   116,    87,   117,   132,   133,
     223,   224,   156,   171,   391,   169,   537,   470,   138,   333,
     116,   521,   117,   314,   522,   411,     4,     5,   447,   260,
      88,    89,    90,    91,    92,    93,   260,   247,   248,   315,
     260,   206,   207,   208,   260,   209,   450,   367,   368,   369,
     370,   371,   546,   282,   169,    94,   392,   393,   394,   395,
     433,   178,   434,   172,   571,   572,   321,   183,   218,   182,
     278,   219,   220,   131,   207,   208,   138,   209,   284,   285,
     286,   287,   288,   289,   290,   291,   292,   293,   294,   295,
     296,   297,   298,   299,   300,   301,   275,   184,    79,   187,
      79,   188,   280,   281,   189,   322,   210,   131,   336,   485,
     190,   343,   344,   345,   346,   347,   348,   349,   350,   351,
     352,   353,   354,   355,   356,   357,   358,   359,   360,   131,
     362,   216,   136,   365,   366,   517,   342,   364,   221,   376,
     314,   203,   204,   205,   206,   207,   208,   222,   209,   244,
     315,   405,   406,   385,    79,   315,   315,   119,   119,   390,
     404,   377,   378,   172,   246,   175,   161,   162,   163,   164,
     380,   154,   407,   244,   128,   430,   431,   321,   452,   453,
     314,   493,   321,   321,   400,   252,   400,   455,   453,    95,
     471,   472,    79,    95,    95,    95,   315,   419,    79,   253,
     315,   315,   315,   412,   548,   549,   254,   416,   417,   418,
     255,    95,    95,   256,   257,   258,   265,   423,    79,    79,
      79,   426,   266,   321,   267,   424,   425,   321,   321,   321,
     271,   272,   273,   274,   209,   315,   531,   532,   533,   534,
     535,   536,   205,   206,   207,   208,   547,   209,   363,   136,
     373,   337,   338,   339,   340,   384,   382,   408,   409,   410,
     415,   558,   321,   414,   560,   420,   421,   432,   435,   436,
     438,   451,   454,   445,   192,   193,   194,   195,   196,   390,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,   461,   209,   446,   468,   465,   466,   467,    79,
     462,   478,   479,    79,   315,   315,   482,   483,    79,    79,
     486,   495,   489,   492,   500,   510,   511,   512,   520,   514,
     457,    79,    79,   336,   138,   516,   519,   523,   527,   530,
     543,   321,   321,   528,   529,   561,   562,   570,   573,   383,
     473,   448,   487,    61,   563,    95,   565,   557,   119,    79,
     477,   564,   484,    79,    79,    79,    69,   509,   123,   494,
     154,   113,   170,   341,   437,   268,   490,   400,   491,   401,
     277,   402,     0,   403,     0,     0,     0,     0,     0,     0,
       0,    79,   504,     0,    95,    95,   119,     0,    79,   283,
     518,     0,     0,     0,     0,     0,     0,     0,   525,   526,
       0,     0,   538,     0,     0,     0,     0,   541,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   551,   552,   553,
     554,   555,   556,   509,     0,   559,   540,     0,   542,     0,
       0,     0,     0,   545,   509,    79,     0,     0,     0,     0,
       0,     0,     0,     0,   550,     0,    79,     0,    79,     0,
       0,     0,     0,     0,     0,     0,     0,    79,    79,     0,
       0,     0,    81,     0,     0,     0,     0,     0,     0,     0,
      82,     0,     0,     0,     0,   567,   568,   225,   226,   227,
     228,   229,     0,   230,   231,   232,   233,   234,   235,   236,
     237,   238,   239,   240,   241,     0,   242,   192,   193,   194,
     195,   196,     0,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,     0,   209,    83,    84,    85,
      86,    81,    87,     0,     0,     0,     0,     0,     0,    82,
       0,     0,     0,     0,    81,     0,     0,   148,     0,   149,
     150,     0,    82,     0,     0,     0,    88,    89,    90,    91,
      92,    93,     0,   505,     0,     0,     0,     0,     0,   506,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,    94,     0,     0,     0,     0,    83,    84,    85,    86,
      81,    87,     0,     0,     0,     0,     0,     0,    82,    83,
      84,    85,    86,   243,    87,     0,    81,   145,     0,     0,
       0,     0,     0,   146,    82,    88,    89,    90,    91,    92,
      93,     0,   444,     0,     0,     0,     0,     0,    88,    89,
      90,    91,    92,    93,     0,     0,     0,     0,     0,     0,
      94,     0,     0,     0,     0,    83,    84,    85,    86,    81,
      87,     0,   132,    94,     0,     0,     0,    82,     0,     0,
       0,    83,    84,    85,    86,     0,    87,     0,     0,   140,
       0,     0,     0,     0,    88,    89,    90,    91,    92,    93,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
      88,    89,    90,    91,    92,    93,     0,     0,     0,    94,
       0,     0,     0,     0,    83,    84,    85,    86,     0,    87,
     192,   193,   194,   195,   196,    94,   197,   198,   199,   200,
     201,   202,   203,   204,   205,   206,   207,   208,     0,   209,
       0,     0,     0,    88,    89,    90,    91,    92,    93,     4,
       5,     6,     0,     0,     0,     0,     7,     0,     0,     0,
       0,     8,     0,     9,    10,    11,    12,     0,    94,    13,
     539,    14,    15,    16,     0,    17,    18,    19,    20,     0,
       0,     0,    21,    22,    23,    24,    25,    26,    27,    28,
       0,    29,     0,    30,     0,    31,     0,     0,    32,    33,
       0,     0,     0,     0,     0,     0,     0,     0,    34,    35,
      36,     0,     0,    37,    38,    39,     0,    40,     0,     0,
       0,     0,     0,     0,    41,    42,    43,    44,    45,     0,
      46,    47,     0,     0,     4,     5,     6,    48,     0,    49,
      50,     7,    51,     0,     0,     0,     8,   324,     9,    10,
      11,    12,   325,   326,     0,     0,    14,     0,     0,     0,
      17,     0,    19,    20,     0,     0,     0,    21,    22,    23,
      24,    25,    26,    27,    28,     0,    29,     0,    30,     0,
      31,     0,     0,    32,    33,     0,     0,     0,     0,     0,
       0,     0,     0,    34,    35,    36,     0,     0,    37,    38,
      39,     0,    40,     0,     0,     4,     5,     6,     0,   458,
     459,     0,     7,     0,     0,    46,    47,     8,     0,     9,
      10,    11,    12,     0,    49,    50,     0,    14,     0,     0,
       0,    17,     0,    19,    20,     0,     0,     0,    21,    22,
      23,    24,    25,    26,    27,    28,     0,    29,     0,    30,
       0,    31,     0,     0,    32,    33,     0,     0,     0,     0,
       0,     0,     0,     0,    34,    35,    36,     0,     0,    37,
      38,    39,     0,    40,     0,     0,     0,     4,     5,     6,
       0,     0,     0,     0,     7,     0,    46,    47,   427,     8,
       0,     9,    10,    11,    12,    49,    50,     0,     0,    14,
       0,     0,     0,    17,     0,    19,    20,     0,     0,     0,
      21,    22,    23,    24,    25,    26,    27,    28,     0,    29,
       0,    30,     0,    31,     0,     0,    32,    33,     0,     0,
       0,     0,     0,     0,     0,     0,    34,    35,    36,     0,
       0,    37,    38,    39,     0,    40,     0,     0,     4,     5,
       6,     0,     0,     0,     0,     7,     0,     0,    46,    47,
       8,   428,     9,    10,    11,    12,     0,    49,    50,     0,
      14,     0,     0,     0,    17,     0,    19,    20,     0,     0,
       0,    21,    22,    23,    24,    25,    26,    27,    28,     0,
      29,     0,    30,     0,    31,     0,     0,    32,    33,     0,
       0,     0,     0,     0,     0,     0,     0,    34,    35,    36,
       0,     0,    37,    38,    39,     0,    40,     0,     0,     4,
       5,     6,     0,     0,     0,     0,     7,     0,     0,    46,
      47,     8,   429,     9,    10,    11,    12,     0,    49,    50,
       0,    14,     0,     0,     0,    17,     0,    19,    20,     0,
       0,     0,    21,    22,    23,    24,    25,    26,    27,    28,
       0,    29,     0,    30,     0,    31,     0,     0,    32,    33,
       0,     0,     0,     0,     0,     0,     0,     0,    34,    35,
      36,     0,     0,    37,    38,    39,     0,    40,     0,     0,
       4,     5,     6,     0,     0,     0,     0,     7,     0,     0,
      46,    47,     8,     0,     9,    10,    11,    12,     0,    49,
      50,   475,    14,     0,     0,     0,    17,     0,    19,    20,
       0,     0,     0,    21,    22,    23,    24,    25,    26,    27,
      28,     0,    29,     0,    30,     0,    31,     0,     0,    32,
      33,     0,     0,     0,     0,     0,     0,     0,     0,    34,
      35,    36,     0,     0,    37,    38,    39,     0,    40,     0,
       0,     4,     5,     6,     0,     0,     0,     0,     7,     0,
       0,    46,    47,     8,     0,     9,    10,    11,    12,     0,
      49,    50,     0,    14,     0,     0,   476,    17,     0,    19,
      20,     0,     0,     0,    21,    22,    23,    24,    25,    26,
      27,    28,     0,    29,     0,    30,     0,    31,     0,     0,
      32,    33,     0,     0,     0,     0,     0,     0,     0,     0,
      34,    35,    36,     0,     0,    37,    38,    39,     0,    40,
       0,     0,     4,     5,     6,     0,     0,     0,     0,     7,
       0,     0,    46,    47,     8,     0,     9,    10,    11,    12,
       0,    49,    50,     0,    14,     0,     0,     0,    17,     0,
      19,    20,     0,     0,   566,    21,    22,    23,    24,    25,
      26,    27,    28,     0,    29,     0,    30,     0,    31,     0,
       0,    32,    33,     0,     0,     0,     0,     0,     0,     0,
       0,    34,    35,    36,     0,     0,    37,    38,    39,     0,
      40,     0,     0,   302,     0,   303,     0,   304,     0,     0,
     305,     0,     0,    46,    47,   306,     0,   307,    10,   308,
     309,     0,    49,    50,     0,    14,     0,     0,     0,    17,
       0,    19,   310,     0,     0,     0,    21,    22,    23,    24,
      25,    26,    27,   311,     0,   312,     0,    30,     0,    31,
       0,     0,    32,    33,     0,     0,     0,     0,     0,     0,
       0,     0,    34,    35,    36,     0,     0,    37,    38,    39,
       0,    40,     0,     0,     4,     5,     6,     0,     0,     0,
       0,     7,     0,     0,    46,    47,     8,     0,     9,    10,
      11,    12,     0,    49,    50,     0,    14,     0,     0,     0,
      17,     0,    19,    20,     0,     0,     0,    21,    22,    23,
      24,    25,    26,    27,    28,     0,    29,     0,    30,     0,
      31,     0,     0,    32,    33,     0,     0,     0,     0,     0,
       0,     0,     0,    34,    35,    36,     0,     0,    37,    38,
      39,     0,    40,     0,     0,     0,     0,   303,     0,   304,
       0,     0,   305,     0,     0,    46,    47,   306,     0,   307,
      10,   308,   309,     0,    49,    50,     0,    14,     0,     0,
       0,    17,     0,    19,   310,     0,     0,     0,    21,    22,
      23,    24,    25,    26,    27,   311,     0,   312,     0,    30,
       0,    31,     0,     0,    32,    33,     0,     0,     0,     0,
       0,     0,     0,     0,    34,    35,    36,     0,     0,    37,
      38,    39,     0,    40,     0,     0,     0,     0,   303,     0,
       0,     0,     0,   305,     0,     0,    46,    47,   306,     0,
     307,    10,   308,   309,     0,    49,    50,     0,    14,     0,
       0,     0,    17,     0,    19,   310,     0,     0,     0,    21,
      22,    23,    24,    25,    26,    27,   311,     0,   312,     0,
      30,     0,    31,     0,     0,    32,    33,     0,     0,     0,
       0,     0,     0,     0,     0,    34,    35,    36,     0,     0,
      37,    38,    39,     0,    40,     0,     0,     0,     0,   303,
       0,     0,     0,     0,   305,     0,     0,    46,    47,   306,
       0,   307,    10,   308,   309,     0,    49,    50,     0,    14,
       0,     0,     0,    17,     0,    19,   310,     0,     0,     0,
      21,    22,    23,    24,    25,    26,    27,   124,     0,   312,
       0,    30,     0,    31,   124,   125,    32,    33,     0,     0,
       0,     0,   125,  -198,     0,     0,    34,    35,    36,     0,
       0,    37,    38,    39,     0,    40,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,    46,    47,
       0,     0,     0,     0,     0,     0,     0,    49,    50,     0,
       0,     0,    83,    84,    85,    86,     0,    87,     0,    83,
      84,    85,    86,   196,    87,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,     0,   209,     0,
       0,    88,    89,    90,    91,    92,    93,     0,    88,    89,
      90,    91,    92,    93,   192,   193,   194,   195,   196,     0,
     197,   198,   199,   200,   201,   202,   203,   204,   205,   206,
     207,   208,     0,   209,     4,     5,   192,   193,   194,   195,
     196,     0,   197,   198,   199,   200,   201,   202,   203,   204,
     205,   206,   207,   208,     0,   209,     0,   496,   192,   193,
     194,   195,   196,     0,   197,   198,   199,   200,   201,   202,
     203,   204,   205,   206,   207,   208,     0,   209,   456,   192,
     193,   194,   195,   196,     0,   197,   198,   199,   200,   201,
     202,   203,   204,   205,   206,   207,   208,     0,   209,   194,
     195,   196,     0,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,     0,   209,   197,   198,   199,
     200,   201,   202,   203,   204,   205,   206,   207,   208,     0,
     209
};

static const short yycheck[] =
{
       2,    29,     6,    23,    24,     9,     2,    11,    12,    36,
     304,    38,     8,   250,    23,   252,   420,    20,    20,     9,
      52,    11,    12,   187,    31,    27,    30,    31,    32,    33,
     257,    24,    36,    32,    38,    22,    23,    24,    25,   210,
      23,    24,    25,    23,    47,    47,   213,   214,   215,    23,
      23,    49,    50,    40,    23,   210,     8,    40,    23,    35,
      23,    37,    23,    39,    16,    61,    81,   103,    79,    79,
     465,   466,   467,    65,   432,     0,    65,    81,    82,   243,
      36,   110,   210,    65,    66,    41,    42,   119,   117,    64,
      94,    65,    24,   451,   105,   105,   500,   101,    65,   119,
     115,    65,    15,    67,    65,   132,    19,   103,   104,   105,
     119,    63,    64,    65,    66,    63,    68,    65,    70,    71,
     124,   125,    55,   115,    64,    65,   119,   421,   132,   118,
      63,   489,    65,   304,   492,   302,    23,    24,   112,   119,
      92,    93,    94,    95,    96,    97,   119,   119,   120,   304,
     119,    18,    19,    20,   119,    22,   119,    74,    75,    76,
      77,    78,   520,   190,    65,   117,   106,   107,   108,   109,
     337,    65,   339,   171,   569,   570,   304,   121,   109,   117,
     184,   112,   113,   187,    19,    20,   190,    22,   192,   193,
     194,   195,   196,   197,   198,   199,   200,   201,   202,   203,
     204,   205,   206,   207,   208,   209,   182,    11,   210,   117,
     212,   117,   188,   189,   117,   211,    26,   221,   216,   446,
     117,   225,   226,   227,   228,   229,   230,   231,   232,   233,
     234,   235,   236,   237,   238,   239,   240,   241,   242,   243,
     244,   117,   246,   247,   248,   482,   222,   246,   117,   253,
     421,    15,    16,    17,    18,    19,    20,    11,    22,   119,
     415,   118,   119,   266,   266,   420,   421,   254,   255,   267,
     274,   254,   255,   271,   119,   273,    42,    43,    44,    45,
     256,   257,   118,   119,   312,   118,   119,   415,   118,   119,
     461,   458,   420,   421,   270,   119,   272,   118,   119,   303,
      31,    32,   304,   307,   308,   309,   461,   310,   310,   117,
     465,   466,   467,   303,    31,    32,    57,   307,   308,   309,
      58,   325,   326,   119,   119,    16,   119,   323,   330,   331,
     332,   327,   119,   461,    23,   325,   326,   465,   466,   467,
     119,   117,   119,    11,    22,   500,     9,    10,    11,    12,
      13,    14,    17,    18,    19,    20,   523,    22,   120,   363,
      80,    23,    23,    23,    23,    64,   103,   118,   118,   118,
      24,   538,   500,    31,   541,    24,    27,   110,   118,    53,
     119,   110,    53,   119,     3,     4,     5,     6,     7,   387,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    26,    22,   119,    11,    24,    24,    24,   411,
     414,   438,    79,   415,   569,   570,   110,    58,   420,   421,
      23,    29,   110,   110,    24,    23,    23,    54,   110,   119,
     406,   433,   434,   431,   438,    79,   119,    26,    34,    53,
      96,   569,   570,    36,    36,    11,   119,    24,    55,   260,
     431,   387,   450,     2,   547,   459,   550,   537,   445,   461,
     436,   548,   445,   465,   466,   467,     2,   471,    27,   459,
     446,    18,    48,   221,   363,   171,   453,   453,   454,   271,
     183,   272,    -1,   273,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   493,   468,    -1,   498,   499,   483,    -1,   500,   118,
     483,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   498,   499,
      -1,    -1,   508,    -1,    -1,    -1,    -1,   513,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   531,   532,   533,
     534,   535,   536,   537,    -1,   539,   512,    -1,   514,    -1,
      -1,    -1,    -1,   519,   548,   547,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   530,    -1,   558,    -1,   560,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   569,   570,    -1,
      -1,    -1,     8,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      16,    -1,    -1,    -1,    -1,   561,   562,     3,     4,     5,
       6,     7,    -1,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    -1,    22,     3,     4,     5,
       6,     7,    -1,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    -1,    22,    63,    64,    65,
      66,     8,    68,    -1,    -1,    -1,    -1,    -1,    -1,    16,
      -1,    -1,    -1,    -1,     8,    -1,    -1,    83,    -1,    85,
      86,    -1,    16,    -1,    -1,    -1,    92,    93,    94,    95,
      96,    97,    -1,    27,    -1,    -1,    -1,    -1,    -1,    33,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,   117,    -1,    -1,    -1,    -1,    63,    64,    65,    66,
       8,    68,    -1,    -1,    -1,    -1,    -1,    -1,    16,    63,
      64,    65,    66,   119,    68,    -1,     8,    84,    -1,    -1,
      -1,    -1,    -1,    90,    16,    92,    93,    94,    95,    96,
      97,    -1,   118,    -1,    -1,    -1,    -1,    -1,    92,    93,
      94,    95,    96,    97,    -1,    -1,    -1,    -1,    -1,    -1,
     117,    -1,    -1,    -1,    -1,    63,    64,    65,    66,     8,
      68,    -1,    70,   117,    -1,    -1,    -1,    16,    -1,    -1,
      -1,    63,    64,    65,    66,    -1,    68,    -1,    -1,    71,
      -1,    -1,    -1,    -1,    92,    93,    94,    95,    96,    97,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      92,    93,    94,    95,    96,    97,    -1,    -1,    -1,   117,
      -1,    -1,    -1,    -1,    63,    64,    65,    66,    -1,    68,
       3,     4,     5,     6,     7,   117,     9,    10,    11,    12,
      13,    14,    15,    16,    17,    18,    19,    20,    -1,    22,
      -1,    -1,    -1,    92,    93,    94,    95,    96,    97,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,    -1,
      -1,    35,    -1,    37,    38,    39,    40,    -1,   117,    43,
      53,    45,    46,    47,    -1,    49,    50,    51,    52,    -1,
      -1,    -1,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    -1,    67,    -1,    69,    -1,    -1,    72,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    82,    83,
      84,    -1,    -1,    87,    88,    89,    -1,    91,    -1,    -1,
      -1,    -1,    -1,    -1,    98,    99,   100,   101,   102,    -1,
     104,   105,    -1,    -1,    23,    24,    25,   111,    -1,   113,
     114,    30,   116,    -1,    -1,    -1,    35,    36,    37,    38,
      39,    40,    41,    42,    -1,    -1,    45,    -1,    -1,    -1,
      49,    -1,    51,    52,    -1,    -1,    -1,    56,    57,    58,
      59,    60,    61,    62,    63,    -1,    65,    -1,    67,    -1,
      69,    -1,    -1,    72,    73,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    82,    83,    84,    -1,    -1,    87,    88,
      89,    -1,    91,    -1,    -1,    23,    24,    25,    -1,    27,
      28,    -1,    30,    -1,    -1,   104,   105,    35,    -1,    37,
      38,    39,    40,    -1,   113,   114,    -1,    45,    -1,    -1,
      -1,    49,    -1,    51,    52,    -1,    -1,    -1,    56,    57,
      58,    59,    60,    61,    62,    63,    -1,    65,    -1,    67,
      -1,    69,    -1,    -1,    72,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    82,    83,    84,    -1,    -1,    87,
      88,    89,    -1,    91,    -1,    -1,    -1,    23,    24,    25,
      -1,    -1,    -1,    -1,    30,    -1,   104,   105,    34,    35,
      -1,    37,    38,    39,    40,   113,   114,    -1,    -1,    45,
      -1,    -1,    -1,    49,    -1,    51,    52,    -1,    -1,    -1,
      56,    57,    58,    59,    60,    61,    62,    63,    -1,    65,
      -1,    67,    -1,    69,    -1,    -1,    72,    73,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    82,    83,    84,    -1,
      -1,    87,    88,    89,    -1,    91,    -1,    -1,    23,    24,
      25,    -1,    -1,    -1,    -1,    30,    -1,    -1,   104,   105,
      35,    36,    37,    38,    39,    40,    -1,   113,   114,    -1,
      45,    -1,    -1,    -1,    49,    -1,    51,    52,    -1,    -1,
      -1,    56,    57,    58,    59,    60,    61,    62,    63,    -1,
      65,    -1,    67,    -1,    69,    -1,    -1,    72,    73,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    82,    83,    84,
      -1,    -1,    87,    88,    89,    -1,    91,    -1,    -1,    23,
      24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,   104,
     105,    35,    36,    37,    38,    39,    40,    -1,   113,   114,
      -1,    45,    -1,    -1,    -1,    49,    -1,    51,    52,    -1,
      -1,    -1,    56,    57,    58,    59,    60,    61,    62,    63,
      -1,    65,    -1,    67,    -1,    69,    -1,    -1,    72,    73,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    82,    83,
      84,    -1,    -1,    87,    88,    89,    -1,    91,    -1,    -1,
      23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,    -1,
     104,   105,    35,    -1,    37,    38,    39,    40,    -1,   113,
     114,    44,    45,    -1,    -1,    -1,    49,    -1,    51,    52,
      -1,    -1,    -1,    56,    57,    58,    59,    60,    61,    62,
      63,    -1,    65,    -1,    67,    -1,    69,    -1,    -1,    72,
      73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    82,
      83,    84,    -1,    -1,    87,    88,    89,    -1,    91,    -1,
      -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,    -1,
      -1,   104,   105,    35,    -1,    37,    38,    39,    40,    -1,
     113,   114,    -1,    45,    -1,    -1,    48,    49,    -1,    51,
      52,    -1,    -1,    -1,    56,    57,    58,    59,    60,    61,
      62,    63,    -1,    65,    -1,    67,    -1,    69,    -1,    -1,
      72,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      82,    83,    84,    -1,    -1,    87,    88,    89,    -1,    91,
      -1,    -1,    23,    24,    25,    -1,    -1,    -1,    -1,    30,
      -1,    -1,   104,   105,    35,    -1,    37,    38,    39,    40,
      -1,   113,   114,    -1,    45,    -1,    -1,    -1,    49,    -1,
      51,    52,    -1,    -1,    55,    56,    57,    58,    59,    60,
      61,    62,    63,    -1,    65,    -1,    67,    -1,    69,    -1,
      -1,    72,    73,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    82,    83,    84,    -1,    -1,    87,    88,    89,    -1,
      91,    -1,    -1,    23,    -1,    25,    -1,    27,    -1,    -1,
      30,    -1,    -1,   104,   105,    35,    -1,    37,    38,    39,
      40,    -1,   113,   114,    -1,    45,    -1,    -1,    -1,    49,
      -1,    51,    52,    -1,    -1,    -1,    56,    57,    58,    59,
      60,    61,    62,    63,    -1,    65,    -1,    67,    -1,    69,
      -1,    -1,    72,    73,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    82,    83,    84,    -1,    -1,    87,    88,    89,
      -1,    91,    -1,    -1,    23,    24,    25,    -1,    -1,    -1,
      -1,    30,    -1,    -1,   104,   105,    35,    -1,    37,    38,
      39,    40,    -1,   113,   114,    -1,    45,    -1,    -1,    -1,
      49,    -1,    51,    52,    -1,    -1,    -1,    56,    57,    58,
      59,    60,    61,    62,    63,    -1,    65,    -1,    67,    -1,
      69,    -1,    -1,    72,    73,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    82,    83,    84,    -1,    -1,    87,    88,
      89,    -1,    91,    -1,    -1,    -1,    -1,    25,    -1,    27,
      -1,    -1,    30,    -1,    -1,   104,   105,    35,    -1,    37,
      38,    39,    40,    -1,   113,   114,    -1,    45,    -1,    -1,
      -1,    49,    -1,    51,    52,    -1,    -1,    -1,    56,    57,
      58,    59,    60,    61,    62,    63,    -1,    65,    -1,    67,
      -1,    69,    -1,    -1,    72,    73,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    82,    83,    84,    -1,    -1,    87,
      88,    89,    -1,    91,    -1,    -1,    -1,    -1,    25,    -1,
      -1,    -1,    -1,    30,    -1,    -1,   104,   105,    35,    -1,
      37,    38,    39,    40,    -1,   113,   114,    -1,    45,    -1,
      -1,    -1,    49,    -1,    51,    52,    -1,    -1,    -1,    56,
      57,    58,    59,    60,    61,    62,    63,    -1,    65,    -1,
      67,    -1,    69,    -1,    -1,    72,    73,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    82,    83,    84,    -1,    -1,
      87,    88,    89,    -1,    91,    -1,    -1,    -1,    -1,    25,
      -1,    -1,    -1,    -1,    30,    -1,    -1,   104,   105,    35,
      -1,    37,    38,    39,    40,    -1,   113,   114,    -1,    45,
      -1,    -1,    -1,    49,    -1,    51,    52,    -1,    -1,    -1,
      56,    57,    58,    59,    60,    61,    62,     8,    -1,    65,
      -1,    67,    -1,    69,     8,    16,    72,    73,    -1,    -1,
      -1,    -1,    16,    24,    -1,    -1,    82,    83,    84,    -1,
      -1,    87,    88,    89,    -1,    91,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   104,   105,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   113,   114,    -1,
      -1,    -1,    63,    64,    65,    66,    -1,    68,    -1,    63,
      64,    65,    66,     7,    68,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    -1,    22,    -1,
      -1,    92,    93,    94,    95,    96,    97,    -1,    92,    93,
      94,    95,    96,    97,     3,     4,     5,     6,     7,    -1,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    -1,    22,    23,    24,     3,     4,     5,     6,
       7,    -1,     9,    10,    11,    12,    13,    14,    15,    16,
      17,    18,    19,    20,    -1,    22,    -1,    24,     3,     4,
       5,     6,     7,    -1,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    -1,    22,    23,     3,
       4,     5,     6,     7,    -1,     9,    10,    11,    12,    13,
      14,    15,    16,    17,    18,    19,    20,    -1,    22,     5,
       6,     7,    -1,     9,    10,    11,    12,    13,    14,    15,
      16,    17,    18,    19,    20,    -1,    22,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    -1,
      22
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const unsigned char yystos[] =
{
       0,   123,   124,     0,    23,    24,    25,    30,    35,    37,
      38,    39,    40,    43,    45,    46,    47,    49,    50,    51,
      52,    56,    57,    58,    59,    60,    61,    62,    63,    65,
      67,    69,    72,    73,    82,    83,    84,    87,    88,    89,
      91,    98,    99,   100,   101,   102,   104,   105,   111,   113,
     114,   116,   125,   127,   128,   129,   130,   133,   137,   140,
     144,   151,   153,   154,   156,   157,   158,   159,   164,   166,
     169,   173,   174,   180,   181,   184,   186,   194,   210,   211,
     212,     8,    16,    63,    64,    65,    66,    68,    92,    93,
      94,    95,    96,    97,   117,   201,   204,   206,   208,   211,
     214,    31,   164,   204,   204,   204,    65,    67,   182,   182,
      65,    66,   183,   183,   182,   212,    63,    65,   167,   184,
     167,   167,   167,   180,     8,    16,   189,   202,   206,   190,
     191,   201,    70,    71,   192,   193,   201,   192,   201,   205,
      71,   172,   188,   201,   203,    84,    90,   203,    83,    85,
      86,   205,   203,   205,   203,   207,    55,   167,   103,   138,
     139,   138,   138,   138,   138,    64,   170,   171,   212,    65,
     185,   115,   186,   195,   196,   186,   199,   200,    65,   187,
     164,    24,   117,   121,    11,   201,   201,   117,   117,   117,
     117,   201,     3,     4,     5,     6,     7,     9,    10,    11,
      12,    13,    14,    15,    16,    17,    18,    19,    20,    22,
      26,   201,   152,   164,   164,   164,   117,   126,   126,   126,
     126,   117,    11,   201,   201,     3,     4,     5,     6,     7,
       9,    10,    11,    12,    13,    14,    15,    16,    17,    18,
      19,    20,    22,   119,   119,   205,   119,   119,   120,    52,
     119,   175,   119,   117,    57,    58,   119,   119,    16,    23,
     119,    23,    23,    23,    23,   119,   119,    23,   195,   110,
     117,   119,   117,   119,    11,   203,   209,   210,   201,   191,
     203,   203,   205,   118,   201,   201,   201,   201,   201,   201,
     201,   201,   201,   201,   201,   201,   201,   201,   201,   201,
     201,   201,    23,    25,    27,    30,    35,    37,    39,    40,
      52,    63,    65,   141,   143,   144,   145,   146,   147,   148,
     149,   169,   164,   165,    36,    41,    42,   151,   164,   166,
     152,   152,   152,   118,   131,   132,   186,    23,    23,    23,
      23,   190,   203,   201,   201,   201,   201,   201,   201,   201,
     201,   201,   201,   201,   201,   201,   201,   201,   201,   201,
     201,   191,   201,   120,   192,   201,   201,    74,    75,    76,
      77,    78,   188,    80,   176,   188,   201,   167,   167,   168,
     203,   207,   103,   139,    64,   212,    23,   134,   135,   136,
     186,    64,   106,   107,   108,   109,   185,   213,   197,   198,
     203,   196,   197,   200,   201,   118,   119,   118,   118,   118,
     118,   152,   204,   145,    31,    24,   204,   204,   204,   212,
      24,    27,   160,   164,   204,   204,   164,    34,    36,    36,
     118,   119,   110,   152,   152,   118,    53,   193,   119,    79,
     105,    81,   115,   177,   118,   119,   119,   112,   135,    23,
     119,   110,   118,   119,    53,   118,    23,   203,    27,    28,
     155,    26,   201,   142,   143,    24,    24,    24,    11,   141,
     145,    31,    32,   131,   213,    44,    48,   203,   205,    79,
      79,   105,   110,    58,   167,   207,    23,   186,   213,   110,
     198,   203,   110,   152,   204,    29,    24,    36,    41,    42,
      24,   142,   142,   142,   203,    27,    33,   162,   163,   201,
      23,    23,    54,   161,   119,   179,    79,   188,   167,   119,
     110,   213,   213,    26,   150,   204,   204,    34,    36,    36,
      53,     9,    10,    11,    12,    13,    14,   119,   164,    53,
     203,   164,   203,    96,   178,   203,   213,   152,    31,    32,
     203,   201,   201,   201,   201,   201,   201,   162,   152,   201,
     152,    11,   119,   155,   163,   161,    55,   203,   203,    24,
      24,   142,   142,    55
};

#if ! defined (YYSIZE_T) && defined (__SIZE_TYPE__)
# define YYSIZE_T __SIZE_TYPE__
#endif
#if ! defined (YYSIZE_T) && defined (size_t)
# define YYSIZE_T size_t
#endif
#if ! defined (YYSIZE_T)
# if defined (__STDC__) || defined (__cplusplus)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# endif
#endif
#if ! defined (YYSIZE_T)
# define YYSIZE_T unsigned int
#endif

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrlab1


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  */

#define YYFAIL		goto yyerrlab

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      yytoken = YYTRANSLATE (yychar);				\
      YYPOPSTACK;						\
      goto yybackup;						\
    }								\
  else								\
    { 								\
      yyerror ("syntax error: cannot back up");\
      YYERROR;							\
    }								\
while (0)

#define YYTERROR	1
#define YYERRCODE	256

/* YYLLOC_DEFAULT -- Compute the default location (before the actions
   are run).  */

#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)         \
  Current.first_line   = Rhs[1].first_line;      \
  Current.first_column = Rhs[1].first_column;    \
  Current.last_line    = Rhs[N].last_line;       \
  Current.last_column  = Rhs[N].last_column;
#endif

/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (0)

# define YYDSYMPRINT(Args)			\
do {						\
  if (yydebug)					\
    yysymprint Args;				\
} while (0)

# define YYDSYMPRINTF(Title, Token, Value, Location)		\
do {								\
  if (yydebug)							\
    {								\
      YYFPRINTF (stderr, "%s ", Title);				\
      yysymprint (stderr, 					\
                  Token, Value);	\
      YYFPRINTF (stderr, "\n");					\
    }								\
} while (0)

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (cinluded).                                                   |
`------------------------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_stack_print (short *bottom, short *top)
#else
static void
yy_stack_print (bottom, top)
    short *bottom;
    short *top;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (/* Nothing. */; bottom <= top; ++bottom)
    YYFPRINTF (stderr, " %d", *bottom);
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (0)


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yy_reduce_print (int yyrule)
#else
static void
yy_reduce_print (yyrule)
    int yyrule;
#endif
{
  int yyi;
  unsigned int yylineno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %u), ",
             yyrule - 1, yylineno);
  /* Print the symbols being reduced, and their result.  */
  for (yyi = yyprhs[yyrule]; 0 <= yyrhs[yyi]; yyi++)
    YYFPRINTF (stderr, "%s ", yytname [yyrhs[yyi]]);
  YYFPRINTF (stderr, "-> %s\n", yytname [yyr1[yyrule]]);
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (Rule);		\
} while (0)

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YYDSYMPRINT(Args)
# define YYDSYMPRINTF(Title, Token, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   SIZE_MAX < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#if YYMAXDEPTH == 0
# undef YYMAXDEPTH
#endif

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif



#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined (__GLIBC__) && defined (_STRING_H)
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
static YYSIZE_T
#   if defined (__STDC__) || defined (__cplusplus)
yystrlen (const char *yystr)
#   else
yystrlen (yystr)
     const char *yystr;
#   endif
{
  register const char *yys = yystr;

  while (*yys++ != '\0')
    continue;

  return yys - yystr - 1;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined (__GLIBC__) && defined (_STRING_H) && defined (_GNU_SOURCE)
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
static char *
#   if defined (__STDC__) || defined (__cplusplus)
yystpcpy (char *yydest, const char *yysrc)
#   else
yystpcpy (yydest, yysrc)
     char *yydest;
     const char *yysrc;
#   endif
{
  register char *yyd = yydest;
  register const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

#endif /* !YYERROR_VERBOSE */



#if YYDEBUG
/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yysymprint (FILE *yyoutput, int yytype, YYSTYPE *yyvaluep)
#else
static void
yysymprint (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  if (yytype < YYNTOKENS)
    {
      YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
# ifdef YYPRINT
      YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# endif
    }
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  switch (yytype)
    {
      default:
        break;
    }
  YYFPRINTF (yyoutput, ")");
}

#endif /* ! YYDEBUG */
/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

#if defined (__STDC__) || defined (__cplusplus)
static void
yydestruct (int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yytype, yyvaluep)
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  /* Pacify ``unused variable'' warnings.  */
  (void) yyvaluep;

  switch (yytype)
    {

      default:
        break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM);
# else
int yyparse ();
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */



/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;



/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
# if defined (__STDC__) || defined (__cplusplus)
int yyparse (void *YYPARSE_PARAM)
# else
int yyparse (YYPARSE_PARAM)
  void *YYPARSE_PARAM;
# endif
#else /* ! YYPARSE_PARAM */
#if defined (__STDC__) || defined (__cplusplus)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
  
  register int yystate;
  register int yyn;
  int yyresult;
  /* Number of tokens to shift before error messages enabled.  */
  int yyerrstatus;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken = 0;

  /* Three stacks and their tools:
     `yyss': related to states,
     `yyvs': related to semantic values,
     `yyls': related to locations.

     Refer to the stacks thru separate pointers, to allow yyoverflow
     to reallocate them elsewhere.  */

  /* The state stack.  */
  short	yyssa[YYINITDEPTH];
  short *yyss = yyssa;
  register short *yyssp;

  /* The semantic value stack.  */
  YYSTYPE yyvsa[YYINITDEPTH];
  YYSTYPE *yyvs = yyvsa;
  register YYSTYPE *yyvsp;



#define YYPOPSTACK   (yyvsp--, yyssp--)

  YYSIZE_T yystacksize = YYINITDEPTH;

  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;


  /* When reducing, the number of symbols on the RHS of the reduced
     rule.  */
  int yylen;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY;		/* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */

  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed. so pushing a state here evens the stacks.
     */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack. Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	short *yyss1 = yyss;


	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow ("parser stack overflow",
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),

		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyoverflowlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyoverflowlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	short *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyoverflowlab;
	YYSTACK_RELOCATE (yyss);
	YYSTACK_RELOCATE (yyvs);

#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;


      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

/* Do appropriate processing given the current state.  */
/* Read a lookahead token if we need one and don't already have one.  */
/* yyresume: */

  /* First try to decide what to do without reference to lookahead token.  */

  yyn = yypact[yystate];
  if (yyn == YYPACT_NINF)
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YYDSYMPRINTF ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yyn == 0 || yyn == YYTABLE_NINF)
	goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  /* Shift the lookahead token.  */
  YYDPRINTF ((stderr, "Shifting token %s, ", yytname[yytoken]));

  /* Discard the token being shifted unless it is eof.  */
  if (yychar != YYEOF)
    yychar = YYEMPTY;

  *++yyvsp = yylval;


  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  yystate = yyn;
  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
      
    }

/* Line 999 of yacc.c.  */
#line 2047 "qb.tab.c"

  yyvsp -= yylen;
  yyssp -= yylen;


  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;


  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if YYERROR_VERBOSE
      yyn = yypact[yystate];

      if (YYPACT_NINF < yyn && yyn < YYLAST)
	{
	  YYSIZE_T yysize = 0;
	  int yytype = YYTRANSLATE (yychar);
	  char *yymsg;
	  int yyx, yycount;

	  yycount = 0;
	  /* Start YYX at -YYN if negative to avoid negative indexes in
	     YYCHECK.  */
	  for (yyx = yyn < 0 ? -yyn : 0;
	       yyx < (int) (sizeof (yytname) / sizeof (char *)); yyx++)
	    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
	      yysize += yystrlen (yytname[yyx]) + 15, yycount++;
	  yysize += yystrlen ("syntax error, unexpected ") + 1;
	  yysize += yystrlen (yytname[yytype]);
	  yymsg = (char *) YYSTACK_ALLOC (yysize);
	  if (yymsg != 0)
	    {
	      char *yyp = yystpcpy (yymsg, "syntax error, unexpected ");
	      yyp = yystpcpy (yyp, yytname[yytype]);

	      if (yycount < 5)
		{
		  yycount = 0;
		  for (yyx = yyn < 0 ? -yyn : 0;
		       yyx < (int) (sizeof (yytname) / sizeof (char *));
		       yyx++)
		    if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR)
		      {
			const char *yyq = ! yycount ? ", expecting " : " or ";
			yyp = yystpcpy (yyp, yyq);
			yyp = yystpcpy (yyp, yytname[yyx]);
			yycount++;
		      }
		}
	      yyerror (yymsg);
	      YYSTACK_FREE (yymsg);
	    }
	  else
	    yyerror ("syntax error; also virtual memory exhausted");
	}
      else
#endif /* YYERROR_VERBOSE */
	yyerror ("syntax error");
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      /* Return failure if at end of input.  */
      if (yychar == YYEOF)
        {
	  /* Pop the error token.  */
          YYPOPSTACK;
	  /* Pop the rest of the stack.  */
	  while (yyss < yyssp)
	    {
	      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
	      yydestruct (yystos[*yyssp], yyvsp);
	      YYPOPSTACK;
	    }
	  YYABORT;
        }

      YYDSYMPRINTF ("Error: discarding", yytoken, &yylval, &yylloc);
      yydestruct (yytoken, &yylval);
      yychar = YYEMPTY;

    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*----------------------------------------------------.
| yyerrlab1 -- error raised explicitly by an action.  |
`----------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (yyn != YYPACT_NINF)
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;

      YYDSYMPRINTF ("Error: popping", yystos[*yyssp], yyvsp, yylsp);
      yydestruct (yystos[yystate], yyvsp);
      yyvsp--;
      yystate = *--yyssp;

      YY_STACK_PRINT (yyss, yyssp);
    }

  if (yyn == YYFINAL)
    YYACCEPT;

  YYDPRINTF ((stderr, "Shifting error token, "));

  *++yyvsp = yylval;


  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#ifndef yyoverflow
/*----------------------------------------------.
| yyoverflowlab -- parser overflow comes here.  |
`----------------------------------------------*/
yyoverflowlab:
  yyerror ("parser stack overflow");
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
  return yyresult;
}


#line 651 "qb.y"

/* Additional C code */


int main(void)
{
    /*setbuf(stdin,NULL);*/
    yydebug=1;
    yyparse();
    return 0;
}

